import { toRef as ce, resolveComponent as de, createElementBlock as n, openBlock as a, Fragment as m, renderList as D, createCommentVNode as f, createBlock as S, withModifiers as z, createElementVNode as F, toDisplayString as Ie, normalizeStyle as _, createVNode as A, computed as U, onMounted as tt, ref as v, watch as ot, unref as C, normalizeClass as Oe, createSlots as lt, withCtx as x, renderSlot as $, normalizeProps as q, guardReactiveProps as Z, createTextVNode as at, nextTick as Ae } from "vue";
import { u as st, o as nt, e as rt, c as Le, t as it, p as Ue, a as ut, b as ct, X as dt, l as vt, P as ht, q as ft, r as pt, x as gt, y as yt } from "./index-BPqWE-b3.js";
import { _ as mt } from "./Title-DMc-mPaa.js";
import { u as bt, U as kt } from "./usePrinter-BwRGBS5r.js";
import { D as Ct } from "./DataTable-DDf8M9Hq.js";
import { _ as $t } from "./Tooltip-mwG8vT4x.js";
import J from "./BaseIcon-DJEeqZqW.js";
import wt from "./vue-ui-skeleton-Bhvrmh-5.js";
import xt from "./vue-ui-accordion-CacxwDXH.js";
import { u as De } from "./useNestedProp-BCYrFQiV.js";
import { _ as Pt } from "./PackageVersion-D9_yrNr4.js";
import { P as Tt } from "./PenAndPaper-LDJqsGXg.js";
import { u as Ft } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as Rt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const St = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onClick", "onMouseover"], Ot = {
  __name: "RecursiveCircles",
  props: {
    color: {
      type: String,
      default: "#000000"
    },
    dataset: {
      type: Array,
      default: () => []
    },
    hoveredUid: {
      type: String,
      default: null
    },
    linkColor: {
      type: String,
      default: "#CCCCCC"
    },
    stroke: {
      type: String,
      default: "#FFFFFF"
    },
    strokeHovered: {
      type: String,
      default: "#000000"
    }
  },
  emits: ["zoom", "hover"],
  setup(s, { emit: I }) {
    const R = s, p = I;
    function r(i) {
      p("zoom", i);
    }
    function b(i) {
      p("hover", i);
    }
    return ce(R, "dataset").value.forEach((i) => {
      i.nodes && i.nodes.length > 0 && i.nodes.forEach((P) => {
        P.ancestor = i;
      });
    }), (i, P) => {
      const B = de("RecursiveCircles", !0);
      return a(!0), n(m, null, D(s.dataset, (h) => (a(), n(m, null, [
        h.polygonPath && h.polygonPath.coordinates ? (a(), n(m, { key: 0 }, [
          (a(!0), n(m, null, D(h.polygonPath.coordinates, (M, H) => (a(), n("circle", {
            cx: M.x,
            cy: M.y,
            r: h.circleRadius,
            fill: `url(#gradient_${h.color})`,
            stroke: s.hoveredUid && s.hoveredUid === h.uid ? s.strokeHovered : s.stroke,
            "stroke-width": s.hoveredUid && s.hoveredUid === h.uid ? h.circleRadius / 6 : h.circleRadius / 12,
            style: { cursor: "pointer" },
            onClick: z((k) => r(h), ["stop"]),
            onMouseover: (k) => b(h),
            onMouseleave: P[0] || (P[0] = (k) => b(null))
          }, null, 40, St))), 256)),
          h.nodes && h.nodes.length > 0 ? (a(), S(B, {
            key: 0,
            dataset: h.nodes,
            color: s.color,
            stroke: s.stroke,
            strokeHovered: s.strokeHovered,
            hoveredUid: s.hoveredUid,
            onZoom: r,
            onHover: b
          }, null, 8, ["dataset", "color", "stroke", "strokeHovered", "hoveredUid"])) : f("", !0)
        ], 64)) : f("", !0)
      ], 64))), 256);
    };
  }
}, At = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Lt = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Ut = {
  __name: "RecursiveLinks",
  props: {
    dataset: {
      type: Array,
      default: () => []
    },
    color: {
      type: String,
      default: "#DDDDDD"
    },
    backgroundColor: {
      type: String,
      default: "#FFFFFF"
    }
  },
  setup(s) {
    return ce(s, "dataset").value.forEach((p) => {
      p.nodes && p.nodes.length > 0 && p.nodes.forEach((r) => {
        r.ancestor = p;
      });
    }), (p, r) => {
      const b = de("RecursiveLinks", !0);
      return a(), n(m, null, [
        (a(!0), n(m, null, D(s.dataset, (c) => (a(), n(m, null, [
          c.polygonPath && c.polygonPath.coordinates ? (a(!0), n(m, { key: 0 }, D(c.polygonPath.coordinates, (i, P) => (a(), n(m, null, [
            c.ancestor && c.ancestor.polygonPath ? (a(), n(m, { key: 0 }, [
              F("line", {
                x1: i.x,
                y1: i.y,
                x2: c.ancestor.polygonPath.coordinates[0].x,
                y2: c.ancestor.polygonPath.coordinates[0].y,
                stroke: s.backgroundColor,
                "stroke-width": c.circleRadius / 1.5
              }, null, 8, At),
              F("line", {
                x1: i.x,
                y1: i.y,
                x2: c.ancestor.polygonPath.coordinates[0].x,
                y2: c.ancestor.polygonPath.coordinates[0].y,
                stroke: s.color,
                "stroke-width": c.circleRadius / 2
              }, null, 8, Lt)
            ], 64)) : f("", !0)
          ], 64))), 256)) : f("", !0)
        ], 64))), 256)),
        (a(!0), n(m, null, D(s.dataset, (c) => (a(), n(m, null, [
          c.polygonPath && c.polygonPath.coordinates ? (a(), n(m, { key: 0 }, [
            c.nodes && c.nodes.length > 0 ? (a(), S(b, {
              key: 0,
              dataset: c.nodes,
              color: s.color,
              backgroundColor: s.backgroundColor
            }, null, 8, ["dataset", "color", "backgroundColor"])) : f("", !0)
          ], 64)) : f("", !0)
        ], 64))), 256))
      ], 64);
    };
  }
}, Dt = ["x", "y", "fill", "font-size"], It = {
  __name: "RecursiveLabels",
  props: {
    color: {
      type: String,
      default: "#000000"
    },
    dataset: {
      type: Array,
      default: () => []
    },
    hoveredUid: {
      type: String,
      default: null
    }
  },
  emits: ["zoom", "hover"],
  setup(s, { emit: I }) {
    return ce(s, "dataset").value.forEach((r) => {
      r.nodes && r.nodes.length > 0 && r.nodes.forEach((b) => {
        b.ancestor = r;
      });
    }), (r, b) => {
      const c = de("RecursiveLabels", !0);
      return a(!0), n(m, null, D(s.dataset, (i) => (a(), n(m, null, [
        i.polygonPath && i.polygonPath.coordinates ? (a(), n(m, { key: 0 }, [
          (a(!0), n(m, null, D(i.polygonPath.coordinates, (P) => (a(), n("text", {
            x: P.x,
            y: P.y + i.circleRadius * 2,
            fill: s.color,
            "font-size": i.circleRadius,
            "text-anchor": "middle",
            style: { opacity: "0.8", "pointer-events": "none" }
          }, Ie(i.name), 9, Dt))), 256)),
          i.nodes && i.nodes.length > 0 ? (a(), S(c, {
            key: 0,
            dataset: i.nodes,
            color: s.color,
            hoveredUid: s.hoveredUid
          }, null, 8, ["dataset", "color", "hoveredUid"])) : f("", !0)
        ], 64)) : f("", !0)
      ], 64))), 256);
    };
  }
}, Nt = { style: { position: "relative", height: "100%", width: "100%" } }, zt = {
  __name: "BaseDirectionPad",
  props: {
    color: {
      type: String,
      default: "#1A1A1A"
    },
    isFullscreen: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["moveLeft", "moveTop", "moveRight", "moveBottom", "reset"],
  setup(s, { emit: I }) {
    const R = I;
    return (p, r) => (a(), n("div", {
      style: _(`position: ${s.isFullscreen ? "fixed" : "absolute"};bottom:0;right:${s.isFullscreen ? "12px" : "0"};width:80px;height:80px`),
      "data-html2canvas-ignore": ""
    }, [
      F("div", Nt, [
        F("button", {
          onClick: r[0] || (r[0] = z((b) => R("moveLeft"), ["stop"])),
          style: { position: "absolute", left: "0", top: "50%", transform: "translateY(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          A(J, {
            stroke: s.color,
            name: "arrowLeft",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        F("button", {
          onClick: r[1] || (r[1] = z((b) => R("moveTop"), ["stop"])),
          style: { position: "absolute", top: "0", left: "50%", transform: "translateX(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          A(J, {
            stroke: s.color,
            name: "arrowTop",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        F("button", {
          onClick: r[2] || (r[2] = z((b) => R("moveRight"), ["stop"])),
          style: { position: "absolute", right: "0", top: "50%", transform: "translateY(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          A(J, {
            stroke: s.color,
            name: "arrowRight",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        F("button", {
          onClick: r[3] || (r[3] = z((b) => R("moveBottom"), ["stop"])),
          style: { position: "absolute", bottom: "0", left: "50%", transform: "translateX(-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          A(J, {
            stroke: s.color,
            name: "arrowBottom",
            style: { cursor: "pointer" }
          }, null, 8, ["stroke"])
        ]),
        F("button", {
          onClick: r[4] || (r[4] = z((b) => R("reset"), ["stop"])),
          style: { position: "absolute", top: "50%", left: "50%", transform: "translate(-50%,-50%)", height: "24px", width: "24px", padding: "0", background: "transparent", border: "none", display: "flex", "align-items": "center", "justify-content": "center" }
        }, [
          A(J, {
            stroke: s.color,
            name: "close",
            style: { cursor: "pointer" },
            strokeWidth: 2
          }, null, 8, ["stroke"])
        ])
      ])
    ], 4));
  }
}, Bt = ["id"], Mt = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%;background:transparent"
}, Ht = {
  key: 2,
  style: "width:100%;background:transparent;"
}, Et = ["xmlns", "viewBox"], Vt = ["width", "height"], Xt = ["id"], jt = ["stop-color"], Gt = ["stop-color"], Yt = {
  key: 6,
  class: "vue-data-ui-watermark"
}, Wt = {
  key: 8,
  ref: "source",
  dir: "auto"
}, qt = ["innerHTML"], Zt = {
  __name: "vue-ui-molecule",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(s, { expose: I }) {
    const { vue_ui_molecule: R } = st(), p = s, r = U(() => !!p.dataset && p.dataset.length);
    tt(() => {
      b();
    });
    function b() {
      nt(p.dataset) && rt({
        componentName: "VueUiMolecule",
        type: "dataset"
      });
    }
    const c = v(Le()), i = v(null), P = v(!1), B = v(""), h = v(null), M = v(null), H = v(!1), k = v(null), ve = v(null), ee = v(0), he = v(0), fe = v(0), t = U({
      get: () => ye(),
      set: (e) => e
    }), { userOptionsVisible: te, setUserOptionsVisibility: pe, keepUserOptionState: ge } = Ft({ config: t.value });
    function ye() {
      const e = De({
        userConfig: p.config,
        defaultConfig: R
      });
      return e.theme ? {
        ...De({
          userConfig: ut.vue_ui_molecule[e.theme] || p.config,
          defaultConfig: e
        }),
        customPalette: it[e.theme] || Ue
      } : e;
    }
    ot(() => p.config, (e) => {
      t.value = ye(), te.value = !t.value.userOptions.showOnChartHover, b(), he.value += 1, fe.value += 1, w.value.showTable = t.value.table.show, w.value.showTooltip = t.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const { isPrinting: me, isImaging: be, generatePdf: ke, generateImage: Ce } = bt({
      elementId: `cluster_${c.value}`,
      fileName: t.value.style.chart.title.text || "vue-ui-molecule"
    }), Ne = U(() => t.value.userOptions.show && !t.value.style.chart.title.text), ze = U(() => ct(t.value.customPalette)), w = v({
      showTable: t.value.table.show,
      showDataLabels: !0,
      showTooltip: t.value.style.chart.tooltip.show
    });
    function $e(e, o = 0) {
      return Array.isArray(e) && e.length > 0 && e[0].nodes ? $e(e[0].nodes, o + 1) : o;
    }
    function Be() {
      const e = $e(p.dataset);
      let o = 100, l = o;
      for (let d = 0; d < e; d += 1)
        o /= 1, l += o;
      return {
        height: l,
        width: l
      };
    }
    const T = v(Be()), oe = v(`0 0 ${T.value.width} ${T.value.height}`);
    function we(e, o = { x: -T.value.width / 2.43, y: T.value.height / 2 }, l = T.value.width / 1.1, d = 24, u = 0, g = 0, G = "#BBBBBB") {
      if (e && e.length > 0) {
        const ie = ht({
          plot: o,
          radius: l,
          sides: e.length,
          rotation: u
        });
        e.forEach((y, N) => {
          const Y = ie.coordinates[N];
          let L;
          if (y.ancestor ? y.ancestor.ancestor ? L = y.ancestor.color || G : (L = ze.value[g] || Ue[g] || G, g += 1) : L = G, y.polygonPath = {
            coordinates: [Y]
          }, y.circleRadius = d, y.color = L, y.uid = Le(), y.nodes && y.nodes.length > 0) {
            const ue = !y.ancestor || !y.ancestor.ancestor ? g : 0;
            y.nodes = we(
              y.nodes,
              Y,
              l / 2.9,
              d / 2.2,
              u + Math.PI * N / y.nodes.length,
              ue,
              L
            );
          }
        });
      }
      return e;
    }
    function Me(e) {
      const o = /* @__PURE__ */ new Set();
      function l(u) {
        u.forEach((g) => {
          g.color && !o.has(g.color) && o.add(g.color), g.nodes && g.nodes.length > 0 && l(g.nodes);
        });
      }
      l(e);
      const d = {};
      return Array.from(o).forEach((u, g) => {
        d[u] = `gradient_${g}`;
      }), d;
    }
    const He = U(() => Me(O.value)), O = U(() => we(p.dataset));
    function le() {
      H.value = !1, M.value = null, ve.value = null, k.value = null, se({
        polygonPath: {
          coordinates: [{ x: T.value.width / 2, y: T.value.height / 2 }]
        },
        circleRadius: 24
      });
    }
    const ae = v(null);
    function se(e) {
      h.value.focus(), Ae(() => {
        ae.value && cancelAnimationFrame(ae.value);
        const o = oe.value.split(" "), l = parseFloat(o[0]), d = parseFloat(o[1]), u = parseFloat(o[2]), g = parseFloat(o[3]), { x: G, y: ie } = e.polygonPath.coordinates[0], { circleRadius: y } = e, N = 8.34, Y = G - y * N, L = ie - y * N, ue = y * N * 2, Ze = y * N * 2, Je = Math.sqrt((Y - l) ** 2 + (L - d) ** 2), W = Math.min(1200, Math.max(20, Math.floor(Je / 10))), Ke = (Y - l) / W, Qe = (L - d) / W, _e = (ue - u) / W, et = (Ze - g) / W;
        let X = 0;
        function Se() {
          oe.value = `${l + Ke * X} ${d + Qe * X} ${u + _e * X} ${g + et * X}`, X += t.value.style.chart.zoom.speed, X <= W && (ae.value = requestAnimationFrame(Se));
        }
        Se();
      });
    }
    function Ee(e) {
      M.value === e.uid ? le() : (M.value = e.uid, ve.value = e, k.value = {
        circleRadius: e.circleRadius,
        polygonPath: {
          coordinates: [{ x: e.polygonPath.coordinates[0].x, y: e.polygonPath.coordinates[0].y }]
        }
      }, se(e), H.value = e.uid !== O.value[0].uid);
    }
    function Ve(e) {
      if (e.target.nodeName !== "circle")
        le(), H.value = !1;
      else
        return;
    }
    const ne = v(null);
    function Xe(e) {
      ne.value = {
        datapoint: e,
        seriesIndex: -1,
        series: O.value,
        config: t.value
      };
      const o = t.value.style.chart.tooltip.customFormat;
      if (gt(o) && yt(() => o({
        seriesIndex: -1,
        datapoint: e,
        series: O.value,
        config: t.value
      })))
        B.value = o({
          seriesIndex: -1,
          // well, ok
          datapoint: e,
          series: O.value,
          config: t.value
        });
      else {
        let l = "";
        l += `<div style="display:flex;align-items:center;gap:3px"><div style="color:${e.color}">⬤</div><div>${e.name}</div></div>`, e.details && (l += `<div style="width:100%;border-top:1px solid ${t.value.style.chart.tooltip.borderColor};margin-top: 2px">${e.details}</div>`), B.value = `<div style="font-family:inherit">${l}</div>`;
      }
    }
    const xe = v(null), j = v(null);
    function je(e) {
      xe.value = e, e ? (P.value = !0, Xe(e), j.value = e.uid) : (P.value = !1, B.value = "", j.value = null);
    }
    function K(e) {
      e === "right" && (k.value.polygonPath.coordinates[0].x += k.value.circleRadius), e === "left" && (k.value.polygonPath.coordinates[0].x -= k.value.circleRadius), e === "top" && (k.value.polygonPath.coordinates[0].y -= k.value.circleRadius), e === "bottom" && (k.value.polygonPath.coordinates[0].y += k.value.circleRadius), se(k.value);
    }
    function Ge(e) {
      const o = [];
      function l(d) {
        d.forEach((u) => {
          const g = {
            name: u.name,
            details: u.details || "-",
            ancestor: u.ancestor && u.ancestor.name || "-",
            color: u.color || ""
          };
          o.push(g), u.nodes && u.nodes.length > 0 && l(u.nodes, u.name);
        });
      }
      return l(e), o;
    }
    const Ye = U(() => Ge(O.value)), E = U(() => {
      const e = [
        t.value.table.translations.nodeName,
        t.value.table.translations.details,
        t.value.table.translations.ancestor
      ], o = Ye.value.map((u, g) => [
        {
          color: u.color,
          name: u.name
        },
        u.details,
        u.ancestor || ""
      ]), l = {
        th: {
          backgroundColor: t.value.table.th.backgroundColor,
          color: t.value.table.th.color,
          outline: t.value.table.th.outline
        },
        td: {
          backgroundColor: t.value.table.td.backgroundColor,
          color: t.value.table.td.color,
          outline: t.value.table.td.outline
        },
        breakpoint: t.value.table.responsiveBreakpoint
      }, d = [
        t.value.table.translations.nodeName,
        t.value.table.translations.details,
        t.value.table.translations.ancestor
      ];
      return {
        head: e,
        body: o,
        config: l,
        colNames: d
      };
    });
    function Pe() {
      Ae(() => {
        const e = E.value.body.map((d, u) => [[d[0].name], [d[1]], [d[2]]]), o = [[t.value.style.chart.title.text], [t.value.style.chart.title.subtitle.text], [[...E.value.head]]].concat(e), l = ft(o);
        pt({ csvContent: l, title: t.value.style.chart.title.text || "vue-ui-molecule" });
      });
    }
    function We() {
      return O.value;
    }
    const V = v(!1);
    function qe(e) {
      V.value = e, ee.value += 1;
    }
    function Te() {
      w.value.showTable = !w.value.showTable;
    }
    function Fe() {
      w.value.showDataLabels = !w.value.showDataLabels;
    }
    function Re() {
      w.value.showTooltip = !w.value.showTooltip;
    }
    const Q = v(!1);
    function re() {
      Q.value = !Q.value;
    }
    return I({
      getData: We,
      generatePdf: ke,
      generateCsv: Pe,
      generateImage: Ce,
      toggleTable: Te,
      toggleLabels: Fe,
      toggleTooltip: Re,
      toggleAnnotator: re
    }), (e, o) => (a(), n("div", {
      ref_key: "moleculeChart",
      ref: h,
      class: Oe(`vue-ui-molecule ${V.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: _(`font-family:${t.value.style.fontFamily};width:100%; text-align:center;background:${t.value.style.chart.backgroundColor}`),
      id: `cluster_${c.value}`,
      onMouseleave: o[7] || (o[7] = (l) => {
        xe.value = null, j.value = null, C(pe)(!1);
      }),
      onMouseenter: o[8] || (o[8] = () => C(pe)(!0))
    }, [
      t.value.userOptions.buttons.annotator ? (a(), S(Tt, {
        key: 0,
        parent: h.value,
        backgroundColor: t.value.style.chart.backgroundColor,
        color: t.value.style.chart.color,
        active: Q.value,
        onClose: re
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : f("", !0),
      Ne.value ? (a(), n("div", Mt, null, 512)) : f("", !0),
      t.value.style.chart.title.text ? (a(), n("div", Ht, [
        (a(), S(mt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "molecule-div-title",
              ...t.value.style.chart.title
            },
            subtitle: {
              cy: "molecule-div-subtitle",
              ...t.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : f("", !0),
      t.value.userOptions.show && r.value && (C(ge) || C(te)) ? (a(), S(kt, {
        ref_key: "details",
        ref: i,
        key: `user_options_${ee.value}`,
        backgroundColor: t.value.style.chart.backgroundColor,
        color: t.value.style.chart.color,
        isPrinting: C(me),
        isImaging: C(be),
        uid: c.value,
        hasTooltip: t.value.userOptions.buttons.tooltip && t.value.style.chart.tooltip.show,
        hasPdf: t.value.userOptions.buttons.pdf,
        hasXls: t.value.userOptions.buttons.csv,
        hasImg: t.value.userOptions.buttons.img,
        hasTable: t.value.userOptions.buttons.table,
        hasLabel: t.value.userOptions.buttons.labels,
        hasFullscreen: t.value.userOptions.buttons.fullscreen,
        isTooltip: w.value.showTooltip,
        titles: { ...t.value.userOptions.buttonTitles },
        chartElement: h.value,
        position: t.value.userOptions.position,
        hasAnnotator: t.value.userOptions.buttons.annotator,
        isAnnotation: Q.value,
        onToggleFullscreen: qe,
        onGeneratePdf: C(ke),
        onGenerateCsv: Pe,
        onGenerateImage: C(Ce),
        onToggleTable: Te,
        onToggleLabels: Fe,
        onToggleTooltip: Re,
        onToggleAnnotator: re,
        style: _({
          visibility: C(ge) ? C(te) ? "visible" : "hidden" : "visible"
        })
      }, lt({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: x(() => [
            $(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: x(() => [
            $(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: x(() => [
            $(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: x(() => [
            $(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: x(() => [
            $(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: x(() => [
            $(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: x(({ toggleFullscreen: l, isFullscreen: d }) => [
            $(e.$slots, "optionFullscreen", q(Z({ toggleFullscreen: l, isFullscreen: d })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: x(({ toggleAnnotator: l, isAnnotator: d }) => [
            $(e.$slots, "optionAnnotator", q(Z({ toggleAnnotator: l, isAnnotator: d })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : f("", !0),
      r.value ? (a(), n("svg", {
        key: 4,
        xmlns: C(dt),
        viewBox: oe.value,
        class: Oe({ "vue-data-ui-fullscreen--on": V.value, "vue-data-ui-fulscreen--off": !V.value }),
        style: _(`overflow: hidden; background:transparent;color:${t.value.style.chart.color}`),
        onClick: o[0] || (o[0] = z((l) => Ve(l), ["stop"]))
      }, [
        A(Pt),
        e.$slots["chart-background"] ? (a(), n("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: T.value.width <= 0 ? 10 : T.value.width,
          height: T.value.height <= 0 ? 10 : T.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          $(e.$slots, "chart-background", {}, void 0, !0)
        ], 8, Vt)) : f("", !0),
        F("defs", null, [
          (a(!0), n(m, null, D(Object.keys(He.value), (l) => (a(), n("radialGradient", {
            id: `gradient_${l}`,
            cx: "50%",
            cy: "30%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            F("stop", {
              offset: "0%",
              "stop-color": C(vt)(l, 0.5)
            }, null, 8, jt),
            F("stop", {
              offset: "100%",
              "stop-color": l
            }, null, 8, Gt)
          ], 8, Xt))), 256))
        ]),
        A(Ut, {
          dataset: O.value,
          color: t.value.style.chart.links.stroke,
          backgroundColor: t.value.style.chart.backgroundColor
        }, null, 8, ["dataset", "color", "backgroundColor"]),
        A(Ot, {
          dataset: O.value,
          hoveredUid: j.value,
          stroke: t.value.style.chart.nodes.stroke,
          strokeHovered: t.value.style.chart.nodes.strokeHovered,
          onZoom: Ee,
          onHover: je
        }, null, 8, ["dataset", "hoveredUid", "stroke", "strokeHovered"]),
        w.value.showDataLabels ? (a(), S(It, {
          key: 1,
          dataset: O.value,
          color: t.value.style.chart.color,
          hoveredUid: j.value
        }, null, 8, ["dataset", "color", "hoveredUid"])) : f("", !0),
        $(e.$slots, "svg", { svg: T.value }, void 0, !0)
      ], 14, Et)) : f("", !0),
      H.value ? (a(), S(zt, {
        key: `direction_pad_${ee.value}`,
        color: t.value.style.chart.color,
        isFullscreen: V.value,
        onMoveLeft: o[1] || (o[1] = (l) => K("left")),
        onMoveRight: o[2] || (o[2] = (l) => K("right")),
        onMoveTop: o[3] || (o[3] = (l) => K("top")),
        onMoveBottom: o[4] || (o[4] = (l) => K("bottom")),
        onReset: o[5] || (o[5] = (l) => {
          le(), H.value = !1;
        })
      }, null, 8, ["color", "isFullscreen"])) : f("", !0),
      e.$slots.watermark ? (a(), n("div", Yt, [
        $(e.$slots, "watermark", q(Z({ isPrinting: C(me) || C(be) })), void 0, !0)
      ])) : f("", !0),
      r.value ? f("", !0) : (a(), S(wt, {
        key: 7,
        config: {
          type: "molecule",
          style: {
            backgroundColor: t.value.style.chart.backgroundColor,
            molecule: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.$slots.source ? (a(), n("div", Wt, [
        $(e.$slots, "source", {}, void 0, !0)
      ], 512)) : f("", !0),
      A($t, {
        show: w.value.showTooltip && P.value,
        backgroundColor: t.value.style.chart.tooltip.backgroundColor,
        color: t.value.style.chart.tooltip.color,
        borderRadius: t.value.style.chart.tooltip.borderRadius,
        borderColor: t.value.style.chart.tooltip.borderColor,
        borderWidth: t.value.style.chart.tooltip.borderWidth,
        fontSize: t.value.style.chart.tooltip.fontSize,
        backgroundOpacity: t.value.style.chart.tooltip.backgroundOpacity,
        position: t.value.style.chart.tooltip.position,
        offsetY: t.value.style.chart.tooltip.offsetY,
        parent: h.value,
        content: B.value,
        isFullscreen: V.value,
        isCustom: t.value.style.chart.tooltip.customFormat && typeof t.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": x(() => [
          $(e.$slots, "tooltip-before", q(Z({ ...ne.value })), void 0, !0)
        ]),
        "tooltip-after": x(() => [
          $(e.$slots, "tooltip-after", q(Z({ ...ne.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
      r.value ? (a(), S(xt, {
        key: 9,
        hideDetails: "",
        config: {
          open: w.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: t.value.style.chart.backgroundColor,
            color: t.value.style.chart.color
          },
          head: {
            backgroundColor: t.value.style.chart.backgroundColor,
            color: t.value.style.chart.color
          }
        }
      }, {
        content: x(() => [
          (a(), S(Ct, {
            key: `table_${fe.value}`,
            colNames: E.value.colNames,
            head: E.value.head,
            body: E.value.body,
            config: E.value.config,
            title: `${t.value.style.chart.title.text}${t.value.style.chart.title.subtitle.text ? ` : ${t.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[6] || (o[6] = (l) => w.value.showTable = !1)
          }, {
            th: x(({ th: l }) => [
              F("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, qt)
            ]),
            td: x(({ td: l }) => [
              at(Ie(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : f("", !0)
    ], 46, Bt));
  }
}, co = /* @__PURE__ */ Rt(Zt, [["__scopeId", "data-v-c9ee14bc"]]);
export {
  co as default
};
