import { computed as m, ref as i, watch as Ve, onMounted as at, onBeforeUnmount as ot, createElementBlock as n, openBlock as u, unref as r, normalizeStyle as K, normalizeClass as P, createBlock as D, createCommentVNode as f, createVNode as Me, createSlots as st, withCtx as k, renderSlot as w, normalizeProps as B, guardReactiveProps as E, createElementVNode as b, Fragment as C, renderList as F, toDisplayString as S, createTextVNode as Q, nextTick as ut } from "vue";
import { u as nt, c as rt, t as it, p as Z, a as dt, o as vt, e as M, b as ct, J as Ue, d as ft, m as Be, f as x, X as ht, s as Ee, L as yt, k as ie, n as U, i as R, x as Re, q as pt, r as bt, y as gt } from "./index-BPqWE-b3.js";
import { t as mt, u as kt } from "./useResponsive-BWapHhVH.js";
import { _ as wt } from "./Title-DMc-mPaa.js";
import { u as $t, U as Lt } from "./usePrinter-BwRGBS5r.js";
import { D as Ct } from "./DataTable-DDf8M9Hq.js";
import { _ as xt } from "./Tooltip-mwG8vT4x.js";
import { L as _t } from "./Legend-Doua5Aae.js";
import Tt from "./vue-ui-skeleton-Bhvrmh-5.js";
import Ft from "./vue-ui-accordion-CacxwDXH.js";
import { u as Ge } from "./useNestedProp-BCYrFQiV.js";
import { _ as Nt } from "./PackageVersion-D9_yrNr4.js";
import { P as St } from "./PenAndPaper-LDJqsGXg.js";
import { u as Ot } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as At } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const It = ["id"], Pt = ["xmlns", "viewBox"], Dt = ["width", "height"], zt = ["id"], Vt = ["offset", "stop-color"], Mt = ["offset", "stop-opacity"], Ut = ["id"], Bt = ["id"], Et = ["id"], Rt = ["flood-color"], Gt = ["d", "fill", "stroke", "stroke-width", "filter"], Yt = { key: 1 }, Xt = ["d", "fill"], Ht = { key: 2 }, Wt = ["x", "y", "font-size", "font-weight", "fill"], qt = { key: 3 }, Jt = ["filter"], Kt = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Qt = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], Zt = ["text-anchor", "x", "y", "fill", "font-size", "font-weight"], jt = ["d", "fill", "onMouseenter", "onClick"], el = {
  key: 5,
  class: "vue-data-ui-watermark"
}, tl = {
  key: 0,
  class: "vue-ui-nested-donuts-legend-title"
}, ll = ["onClick"], al = ["innerHTML"], ol = {
  __name: "vue-ui-nested-donuts",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(Ye, { expose: Xe, emit: He }) {
    const { vue_ui_nested_donuts: We } = nt(), O = Ye, G = m(() => !!O.dataset && O.dataset.length), $ = i(rt()), j = i(!1), ee = i(""), qe = i(null), de = i(0), z = i(null), ve = i(null), te = i(null), ce = i(null), fe = i(null), he = i(0), ye = i(0), pe = i(0), V = i(!1);
    function Je(t) {
      V.value = t, de.value += 1;
    }
    const e = m({
      get: () => me(),
      set: (t) => t
    }), { userOptionsVisible: le, setUserOptionsVisibility: be, keepUserOptionState: ge } = Ot({ config: e.value });
    function me() {
      const t = Ge({
        userConfig: O.config,
        defaultConfig: We
      });
      return t.theme ? {
        ...Ge({
          userConfig: dt.vue_ui_nested_donuts[t.theme] || O.config,
          defaultConfig: t
        }),
        customPalette: it[t.theme] || Z
      } : t;
    }
    Ve(() => O.config, (t) => {
      e.value = me(), le.value = !e.value.userOptions.showOnChartHover, ke(), he.value += 1, ye.value += 1, pe.value += 1, y.value.dataLabels.show = e.value.style.chart.layout.labels.dataLabels.show, y.value.showTable = e.value.table.show, y.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const Y = i(null);
    at(() => {
      ke();
    });
    function ke() {
      if (vt(O.dataset) && M({
        componentName: "VueUiNestedDonuts",
        type: "dataset"
      }), e.value.responsive) {
        const t = mt(() => {
          const { width: s, height: a } = kt({
            chart: z.value,
            title: e.value.style.chart.title.text ? ve.value : null,
            legend: e.value.style.chart.legend.show ? te.value : null,
            source: ce.value,
            noTitle: fe.value
          });
          requestAnimationFrame(() => {
            c.value.width = s, c.value.height = a;
          });
        });
        Y.value = new ResizeObserver(t), Y.value.observe(z.value.parentNode);
      }
    }
    ot(() => {
      Y.value && Y.value.disconnect();
    });
    const { isPrinting: we, isImaging: $e, generatePdf: Le, generateImage: Ce } = $t({
      elementId: `nested_donuts_${$.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-nested-donuts"
    }), Ke = m(() => e.value.userOptions.show && !e.value.style.chart.title.text), Qe = m(() => ct(e.value.customPalette)), y = i({
      dataLabels: {
        show: e.value.style.chart.layout.labels.dataLabels.show
      },
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), c = i({
      height: 512,
      width: 512
    }), xe = He;
    function Ze({ datapoint: t, index: s }) {
      xe("selectDatapoint", { datapoint: t, index: s });
    }
    const p = i([]), _ = m(() => (O.dataset.forEach((t, s) => {
      [null, void 0].includes(t.name) && M({
        componentName: "VueUiNestedDonuts",
        type: "datasetSerieAttribute",
        property: "name",
        index: s
      }), [null, void 0].includes(t.series) ? M({
        componentName: "VueUiNestedDonuts",
        type: "datasetSerieAttribute",
        property: "series",
        index: s
      }) : t.series.length === 0 ? M({
        componentName: "VueUiNestedDonuts",
        type: "datasetAttributeEmpty",
        property: `series at index ${s}`
      }) : t.series.forEach((a, o) => {
        [null, void 0].includes(a.name) && M({
          componentName: "VueUiNestedDonuts",
          type: "datasetSerieAttribute",
          property: "name",
          index: o,
          key: "serie"
        }), [null, void 0].includes(a.values) && M({
          componentName: "VueUiNestedDonuts",
          type: "datasetSerieAttribute",
          property: "values",
          index: o,
          key: "serie"
        });
      });
    }), O.dataset.map((t, s) => ({
      ...t,
      total: t.series.filter((a) => !p.value.includes(a.id)).map((a) => Ue(a.values).reduce((o, l) => o + l, 0)).reduce((a, o) => a + o, 0),
      datasetIndex: s,
      id: `${$.value}_${s}`,
      series: t.series.map((a, o) => ({
        name: a.name,
        arcOf: t.name,
        arcOfId: `${$.value}_${s}`,
        id: `${$.value}_${s}_${o}`,
        seriesIndex: o,
        datasetIndex: s,
        color: ft(a.color) || Qe.value[o] || Z[o] || Z[o % Z.length],
        value: Ue(a.values).reduce((l, d) => l + d, 0),
        absoluteValues: a.values || []
      }))
    })))), T = m(() => Math.min(c.value.height, c.value.width) * (e.value.style.chart.layout.donut.strokeWidth / 512)), _e = m(() => [..._.value].map((t, s) => {
      const a = t.series.filter((o) => !p.value.includes(o.id)).map((o) => o.value).reduce((o, l) => o + l, 0);
      return {
        ...t,
        total: a,
        series: t.series.filter((o) => !p.value.includes(o.id)).map((o) => ({
          ...o,
          proportion: o.value / a
        }))
      };
    }));
    function je(t, s, a) {
      let o = 0;
      for (let l = 0; l < t.length; l += 1)
        a.includes(t[l]) && (o += 1);
      return o < s;
    }
    const h = i(_e.value);
    Ve(() => _e.value, (t) => h.value = t);
    const Te = i(null), Fe = i(null);
    function ae(t) {
      xe("selectLegend", t);
      const s = _.value.flatMap((v) => v.series).find((v) => v.id === t.id), a = h.value.flatMap((v) => v.series).find((v) => v.id === t.id);
      let l = a ? a.value : 0;
      const d = _.value.find((v) => v.id === s.arcOfId).series.map((v) => v.id), g = je(d, d.length - 1, p.value);
      if (p.value.includes(t.id)) {
        let v = function() {
          l > s.value ? (cancelAnimationFrame(Te.value), h.value = h.value.map((L) => ({
            ...L,
            series: L.series.map((N) => N.id == t.id ? {
              ...N,
              value: s.value
            } : N)
          }))) : (l += s.value * 0.025, h.value = h.value.map((L) => ({
            ...L,
            series: L.series.map((N) => N.id === t.id ? {
              ...N,
              value: l
            } : N)
          })), Te.value = requestAnimationFrame(v));
        };
        p.value = p.value.filter((L) => L !== t.id), v();
      } else if (g) {
        let v = function() {
          l < 0.1 ? (cancelAnimationFrame(Fe.value), p.value.push(t.id), h.value = h.value.map((L, N) => ({
            ...L,
            series: L.series.map((I) => I.id === t.id ? {
              ...I,
              value: 0
            } : I)
          }))) : (l /= 1.1, h.value = h.value.map((L, N) => ({
            ...L,
            series: L.series.map((I) => I.id === t.id ? {
              ...I,
              value: l
            } : I)
          })), Fe.value = requestAnimationFrame(v));
        };
        v();
      }
    }
    const oe = m(() => T.value / _.value.length * e.value.style.chart.layout.donut.spacingRatio), Ne = m(() => h.value.map((t, s) => T.value - s * T.value / _.value.length)), X = m(() => h.value.map((t, s) => {
      const a = s * T.value / _.value.length;
      return {
        ...t,
        radius: T.value - a,
        donut: Be(
          { series: t.series },
          c.value.width / 2,
          c.value.height / 2,
          T.value - a,
          T.value - a,
          1.99999,
          2,
          1,
          360,
          105.25,
          oe.value
        )
      };
    })), Se = m(() => [..._.value].map((t, s) => {
      const a = s * T.value / _.value.length;
      return {
        sizeRatio: a,
        donut: Be(
          { series: [{ value: 1 }] },
          c.value.width / 2,
          c.value.height / 2,
          T.value - a,
          T.value - a,
          1.99999,
          2,
          1,
          360,
          105.25,
          T.value / _.value.length * e.value.style.chart.layout.donut.spacingRatio
        )[0]
      };
    })), Oe = i(null), H = i(null), W = i(null), se = i(null);
    function et({ datapoint: t, _relativeIndex: s, seriesIndex: a }) {
      Oe.value = t.arcOfId, H.value = t.id, W.value = a, se.value = {
        datapoint: t,
        seriesIndex: a,
        series: h.value,
        config: e.value
      };
      const o = e.value.style.chart.tooltip.customFormat;
      if (Re(o) && gt(() => o({
        seriesIndex: a,
        datapoint: t,
        series: h.value,
        config: e.value
      })))
        ee.value = o({
          seriesIndex: a,
          datapoint: t,
          series: h.value,
          config: e.value
        });
      else {
        let l = "";
        if (e.value.style.chart.tooltip.showAllItemsAtIndex && p.value.length === 0) {
          const d = h.value.map((g) => g.series.find((v) => v.seriesIndex === a));
          d.forEach((g, v) => {
            if (!g) return "";
            l += `
                    <div style="display:flex; flex-direction: column; justify-content:flex-start; align-items:flex-start;padding:6px 0; ${v < d.length - 1 ? `border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor}` : ""}">
                        <div style="display:flex; flex-direction: row; gap: 3px; justify-content:flex-start; align-items:center;">
                            <svg viewBox="0 0 20 20" height="${e.value.style.chart.tooltip.fontSize}" width="${e.value.style.chart.tooltip.fontSize}">
                                <circle cx="10" cy="10" r="10" fill="${g.color}"/>
                            </svg>
                            <span>
                                ${g.arcOf ?? ""} - ${g.name}
                            </span>
                        </div>
                        <span>
                            ${e.value.style.chart.tooltip.showValue ? `<b>${R(
              e.value.style.chart.layout.labels.dataLabels.formatter,
              t.value,
              x({
                p: e.value.style.chart.layout.labels.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.labels.dataLabels.suffix,
                r: e.value.style.chart.tooltip.roundingValue
              }),
              { datapoint: t, seriesIndex: a }
            )}
                        </b>` : ""}
                            ${e.value.style.chart.tooltip.showPercentage ? `(${x({
              v: g.proportion * 100,
              s: "%",
              r: e.value.style.chart.tooltip.roundingPercentage
            })})` : ""}
                        </span>
                    </div>
                `;
          });
        } else
          l += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.arcOf ?? ""} - ${t.name}</div>`, l += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${t.color}"/></svg>`, e.value.style.chart.tooltip.showValue && (l += `<b>${R(
            e.value.style.chart.layout.labels.dataLabels.formatter,
            t.value,
            x({
              p: e.value.style.chart.layout.labels.dataLabels.prefix,
              v: t.value,
              s: e.value.style.chart.layout.labels.dataLabels.suffix,
              r: e.value.style.chart.tooltip.roundingValue
            }),
            { datapoint: t, seriesIndex: a }
          )}</b>`), e.value.style.chart.tooltip.showPercentage && (e.value.style.chart.tooltip.showValue ? l += `<span>(${x({
            v: t.proportion * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          })})</span></div>` : l += `<b>${x({
            v: t.proportion * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          })}</b></div>`);
        ee.value = `<div style="font-size:${e.value.style.chart.tooltip.fontSize}px">${l}</div>`;
      }
      j.value = !0;
    }
    function ue(t) {
      return t.proportion * 100 > e.value.style.chart.layout.labels.dataLabels.hideUnderValue;
    }
    function Ae(t, s) {
      if (!e.value.useBlurOnHover)
        return "";
      if (e.value.style.chart.tooltip.showAllItemsAtIndex && p.value.length === 0)
        return [null, void 0].includes(W.value) || W.value === s ? "" : `url(#blur_${$.value})`;
      if (!e.value.style.chart.tooltip.showAllItemsAtIndex || p.value.length)
        return [null, void 0].includes(H.value) || H.value === t.id ? "" : `url(#blur_${$.value})`;
    }
    const ne = m(() => _.value.map((t, s) => t.series.map((a, o) => ({
      name: a.name,
      color: a.color,
      value: a.value,
      shape: "circle",
      arcOf: a.arcOf,
      id: a.id,
      seriesIndex: o,
      datasetIndex: s,
      total: t.series.filter((l) => !p.value.includes(l.id)).map((l) => l.value).reduce((l, d) => l + d, 0)
    })).map((a) => ({
      ...a,
      opacity: p.value.includes(a.id) ? 0.5 : 1,
      segregate: () => ae(a),
      isSegregated: p.value.includes(a.id)
    })))), tt = m(() => ({
      cy: "nested-donuts-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), A = m(() => {
      const t = h.value.flatMap((a) => a.series.map((o) => ({
        name: `${a.name} - ${o.name}`,
        color: o.color,
        total: a.total
      }))), s = h.value.flatMap((a) => a.series.map((o) => o.value));
      return { head: t, body: s };
    });
    function Ie() {
      ut(() => {
        const t = A.value.head.map((o, l) => [[
          o.name
        ], [A.value.body[l]], [isNaN(A.value.body[l] / o.total) ? "-" : A.value.body[l] / o.total * 100]]), s = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), a = pt(s);
        bt({ csvContent: a, title: e.value.style.chart.title.text || "vue-ui-nested-donuts" });
      });
    }
    const q = m(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ], s = A.value.head.map((l, d) => {
        const g = x({ p: e.value.style.chart.layout.labels.dataLabels.prefix, v: A.value.body[d], s: e.value.style.chart.layout.labels.dataLabels.suffix, r: e.value.table.td.roundingValue });
        return [
          {
            color: l.color,
            name: l.name
          },
          g,
          isNaN(A.value.body[d] / l.total) ? "-" : x({
            v: A.value.body[d] / l.total * 100,
            s: "%",
            r: e.value.table.td.roundingPercentage
          })
        ];
      }), a = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value,
          e.value.table.columnNames.percentage
        ],
        head: t,
        body: s,
        config: a
      };
    });
    function lt() {
      return _.value;
    }
    function Pe() {
      y.value.showTable = !y.value.showTable;
    }
    function De() {
      y.value.dataLabels.show = !y.value.dataLabels.show;
    }
    function ze() {
      y.value.showTooltip = !y.value.showTooltip;
    }
    const J = i(!1);
    function re() {
      J.value = !J.value;
    }
    return Xe({
      getData: lt,
      generatePdf: Le,
      generateCsv: Ie,
      generateImage: Ce,
      toggleTable: Pe,
      toggleLabels: De,
      toggleTooltip: ze,
      toggleAnnotator: re
    }), (t, s) => (u(), n("div", {
      ref_key: "nestedDonutsChart",
      ref: z,
      class: P(`vue-ui-nested-donuts ${V.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: K(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `nested_donuts_${$.value}`,
      onMouseenter: s[3] || (s[3] = () => r(be)(!0)),
      onMouseleave: s[4] || (s[4] = () => r(be)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (u(), D(St, {
        key: 0,
        parent: z.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: J.value,
        onClose: re
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : f("", !0),
      Ke.value ? (u(), n("div", {
        key: 1,
        ref_key: "noTitle",
        ref: fe,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : f("", !0),
      e.value.style.chart.title.text ? (u(), n("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: ve
      }, [
        (u(), D(wt, {
          key: `title_${he.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : f("", !0),
      e.value.userOptions.show && G.value && (r(ge) || r(le)) ? (u(), D(Lt, {
        ref: "details",
        key: `user_option_${de.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: r(we),
        isImaging: r($e),
        uid: $.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasLabel: e.value.userOptions.buttons.labels,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: V.value,
        isTooltip: y.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: z.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: J.value,
        onToggleFullscreen: Je,
        onGeneratePdf: r(Le),
        onGenerateCsv: Ie,
        onGenerateImage: r(Ce),
        onToggleTable: Pe,
        onToggleLabels: De,
        onToggleTooltip: ze,
        onToggleAnnotator: re,
        style: K({
          visibility: r(ge) ? r(le) ? "visible" : "hidden" : "visible"
        })
      }, st({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: k(() => [
            w(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: k(() => [
            w(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: k(() => [
            w(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: k(() => [
            w(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: k(() => [
            w(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionLabels ? {
          name: "optionLabels",
          fn: k(() => [
            w(t.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: k(({ toggleFullscreen: a, isFullscreen: o }) => [
            w(t.$slots, "optionFullscreen", B(E({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: k(({ toggleAnnotator: a, isAnnotator: o }) => [
            w(t.$slots, "optionAnnotator", B(E({ toggleAnnotator: a, isAnnotator: o })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasLabel", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : f("", !0),
      G.value ? (u(), n("svg", {
        key: 4,
        xmlns: r(ht),
        class: P({ "vue-data-ui-fullscreen--on": V.value, "vue-data-ui-fulscreen--off": !V.value }),
        viewBox: `0 0 ${c.value.width <= 0 ? 1e-3 : c.value.width} ${c.value.height < 0 ? 1e-3 : c.value.height}`,
        style: K(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        Me(Nt),
        t.$slots["chart-background"] ? (u(), n("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: c.value.width <= 0 ? 1e-3 : c.value.width,
          height: c.value.height < 0 ? 1e-3 : c.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          w(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Dt)) : f("", !0),
        b("defs", null, [
          (u(!0), n(C, null, F(Se.value, (a, o) => (u(), n("radialGradient", {
            id: `radial_${$.value}_${o}`
          }, [
            s[5] || (s[5] = b("stop", {
              offset: "0%",
              "stop-color": "#FFFFFF",
              "stop-opacity": "0"
            }, null, -1)),
            b("stop", {
              offset: `${(1 - oe.value / Ne.value[o]) * 100}%`,
              "stop-color": r(Ee)("#FFFFFF", 0),
              "stop-opacity": "0"
            }, null, 8, Vt),
            b("stop", {
              offset: `${(1 - oe.value / Ne.value[o] / 2) * 100}%`,
              "stop-color": "#FFFFFF",
              "stop-opacity": e.value.style.chart.gradientIntensity / 100
            }, null, 8, Mt),
            s[6] || (s[6] = b("stop", {
              offset: "100%",
              "stop-color": "#FFFFFF",
              "stop-opacity": "0"
            }, null, -1))
          ], 8, zt))), 256))
        ]),
        b("defs", null, [
          b("filter", {
            id: `blur_${$.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            b("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${$.value}`
            }, null, 8, Bt),
            s[7] || (s[7] = b("feColorMatrix", {
              type: "saturate",
              values: "0"
            }, null, -1))
          ], 8, Ut),
          b("filter", {
            id: `shadow_${$.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            b("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.style.chart.layout.donut.shadowColor
            }, null, 8, Rt)
          ], 8, Et)
        ]),
        (u(!0), n(C, null, F(X.value, (a, o) => (u(), n("g", null, [
          (u(!0), n(C, null, F(a.donut, (l, d) => (u(), n("g", null, [
            b("path", {
              class: "vue-ui-donut-arc-path",
              d: l.arcSlice,
              fill: r(Ee)(l.color, 80),
              stroke: e.value.style.chart.backgroundColor,
              "stroke-width": e.value.style.chart.layout.donut.borderWidth,
              filter: Ae(l, d)
            }, null, 8, Gt)
          ]))), 256))
        ]))), 256)),
        e.value.style.chart.useGradient ? (u(), n("g", Yt, [
          (u(!0), n(C, null, F(Se.value, (a, o) => (u(), n("g", null, [
            b("path", {
              d: a.donut.arcSlice,
              fill: `url(#radial_${$.value}_${o})`,
              stroke: "transparent",
              "stroke-width": "0"
            }, null, 8, Xt)
          ]))), 256))
        ])) : f("", !0),
        e.value.style.chart.layout.labels.dataLabels.showDonutName ? (u(), n("g", Ht, [
          (u(!0), n(C, null, F(X.value, (a, o) => (u(), n("g", null, [
            (u(!0), n(C, null, F(a.donut, (l, d) => (u(), n("g", null, [
              d === 0 && c.value.width && c.value.height ? (u(), n("text", {
                key: 0,
                class: P({ animated: e.value.useCssAnimation }),
                x: c.value.width / 2,
                y: l.startY - e.value.style.chart.layout.labels.dataLabels.fontSize + e.value.style.chart.layout.labels.dataLabels.donutNameOffsetY,
                "text-anchor": "middle",
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldDonutName ? "bold" : "normal",
                fill: e.value.style.chart.layout.labels.dataLabels.color
              }, S(e.value.style.chart.layout.labels.dataLabels.donutNameAbbreviation ? r(yt)({ source: a.name, length: e.value.style.chart.layout.labels.dataLabels.donutNameMaxAbbreviationSize }) : a.name), 11, Wt)) : f("", !0)
            ]))), 256))
          ]))), 256))
        ])) : f("", !0),
        e.value.style.chart.layout.labels.dataLabels.show ? (u(), n("g", qt, [
          (u(!0), n(C, null, F(X.value, (a, o) => (u(), n("g", null, [
            (u(!0), n(C, null, F(a.donut, (l, d) => (u(), n("g", {
              filter: Ae(l, d)
            }, [
              ue(l) && y.value.dataLabels.show && e.value.style.chart.layout.labels.dataLabels.showPercentage ? (u(), n("text", {
                key: 0,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(U)(l, !0).anchor,
                x: r(U)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ie)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY),
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldPercentage ? "bold" : "normal"
              }, S(r(x)({ v: l.proportion * 100, s: "%", r: e.value.style.chart.layout.labels.dataLabels.roundingPercentage })), 11, Kt)) : f("", !0),
              ue(l) && y.value.dataLabels.show && e.value.style.chart.layout.labels.dataLabels.showPercentage && e.value.style.chart.layout.labels.dataLabels.showValue ? (u(), n("text", {
                key: 1,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(U)(l, !0).anchor,
                x: r(U)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ie)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY) + e.value.style.chart.layout.labels.dataLabels.fontSize,
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldValue ? "bold" : "normal"
              }, " (" + S(r(R)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.dataLabels.roundingValue
                }),
                { datapoint: l, seriesIndex: o, datapointIndex: d }
              )) + ") ", 11, Qt)) : f("", !0),
              ue(l) && y.value.dataLabels.show && !e.value.style.chart.layout.labels.dataLabels.showPercentage && e.value.style.chart.layout.labels.dataLabels.showValue ? (u(), n("text", {
                key: 2,
                class: P({ animated: e.value.useCssAnimation }),
                "text-anchor": r(U)(l, !0).anchor,
                x: r(U)(l, !1, e.value.style.chart.layout.labels.dataLabels.offsetX).x || 0,
                y: r(ie)(l, e.value.style.chart.layout.labels.dataLabels.offsetY, e.value.style.chart.layout.labels.dataLabels.offsetY),
                fill: e.value.style.chart.layout.labels.dataLabels.useSerieColor ? l.color : e.value.style.chart.layout.labels.dataLabels.color,
                "font-size": e.value.style.chart.layout.labels.dataLabels.fontSize,
                "font-weight": e.value.style.chart.layout.labels.dataLabels.boldValue ? "bold" : "normal"
              }, S(r(R)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.dataLabels.roundingValue
                }),
                { datapoint: l, seriesIndex: o, datapointIndex: d }
              )), 11, Zt)) : f("", !0)
            ], 8, Jt))), 256))
          ]))), 256))
        ])) : f("", !0),
        (u(!0), n(C, null, F(X.value, (a, o) => (u(), n("g", null, [
          (u(!0), n(C, null, F(a.donut, (l, d) => (u(), n("g", null, [
            b("path", {
              d: l.arcSlice,
              fill: qe.value === o ? "rgba(0,0,0,0.1)" : "transparent",
              onMouseenter: (g) => et({
                datapoint: l,
                seriesIndex: l.seriesIndex
              }),
              onClick: (g) => Ze({ datapoint: l, index: d }),
              onMouseleave: s[0] || (s[0] = (g) => {
                j.value = !1, Oe.value = null, H.value = null, W.value = null;
              })
            }, null, 40, jt)
          ]))), 256))
        ]))), 256)),
        w(t.$slots, "svg", { svg: c.value }, void 0, !0)
      ], 14, Pt)) : f("", !0),
      t.$slots.watermark ? (u(), n("div", el, [
        w(t.$slots, "watermark", B(E({ isPrinting: r(we) || r($e) })), void 0, !0)
      ])) : f("", !0),
      G.value ? f("", !0) : (u(), D(Tt, {
        key: 6,
        config: {
          type: "donut",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donut: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      Me(xt, {
        show: y.value.showTooltip && j.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: z.value,
        content: ee.value,
        isFullscreen: V.value,
        isCustom: r(Re)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": k(() => [
          w(t.$slots, "tooltip-before", B(E({ ...se.value })), void 0, !0)
        ]),
        "tooltip-after": k(() => [
          w(t.$slots, "tooltip-after", B(E({ ...se.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
      e.value.style.chart.legend.show ? (u(), n("div", {
        key: 7,
        ref_key: "chartLegend",
        ref: te,
        class: P({ "vue-ui-nested-donuts-legend": ne.value.length > 1 })
      }, [
        (u(!0), n(C, null, F(ne.value, (a, o) => (u(), D(_t, {
          key: `legend_${o}_${pe.value}`,
          legendSet: a,
          config: tt.value,
          onClickMarker: s[1] || (s[1] = ({ legend: l }) => ae(l))
        }, {
          legendTitle: k(({ titleSet: l }) => [
            l[0] && l[0].arcOf ? (u(), n("div", tl, S(l[0].arcOf), 1)) : f("", !0)
          ]),
          item: k(({ legend: l, index: d }) => [
            b("div", {
              onClick: (g) => ae(l),
              style: K(`opacity:${p.value.includes(l.id) ? 0.5 : 1}`)
            }, [
              Q(S(l.name) + ": " + S(r(R)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                r(x)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: l, seriesIndex: d }
              )) + " ", 1),
              p.value.includes(l.id) ? (u(), n(C, { key: 1 }, [
                Q(" ( - % ) ")
              ], 64)) : (u(), n(C, { key: 0 }, [
                Q(" (" + S(isNaN(l.value / l.total) ? "-" : r(x)({ v: l.value / l.total * 100, s: "%", r: e.value.style.chart.legend.roundingPercentage })) + ") ", 1)
              ], 64))
            ], 12, ll)
          ]),
          _: 2
        }, 1032, ["legendSet", "config"]))), 128))
      ], 2)) : f("", !0),
      e.value.style.chart.legend.show ? f("", !0) : (u(), n("div", {
        key: 8,
        ref_key: "chartLegend",
        ref: te
      }, [
        w(t.$slots, "legend", { legend: ne.value }, void 0, !0)
      ], 512)),
      t.$slots.source ? (u(), n("div", {
        key: 9,
        ref_key: "source",
        ref: ce,
        dir: "auto"
      }, [
        w(t.$slots, "source", {}, void 0, !0)
      ], 512)) : f("", !0),
      G.value ? (u(), D(Ft, {
        key: 10,
        hideDetails: "",
        config: {
          open: y.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: k(() => [
          (u(), D(Ct, {
            key: `table_${ye.value}`,
            colNames: q.value.colNames,
            head: q.value.head,
            body: q.value.body,
            config: q.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: s[2] || (s[2] = (a) => y.value.showTable = !1)
          }, {
            th: k(({ th: a }) => [
              b("div", {
                innerHTML: a,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, al)
            ]),
            td: k(({ td: a }) => [
              Q(S(a.name || a), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : f("", !0)
    ], 46, It));
  }
}, kl = /* @__PURE__ */ At(ol, [["__scopeId", "data-v-93870f32"]]);
export {
  kl as default
};
