import { useSlots as lt, computed as d, ref as v, watch as ze, onMounted as at, onBeforeUnmount as ot, createElementBlock as s, openBlock as r, unref as c, normalizeStyle as W, normalizeClass as Ne, createBlock as N, createCommentVNode as y, createElementVNode as x, createVNode as se, createSlots as Be, withCtx as m, renderSlot as g, normalizeProps as q, guardReactiveProps as H, Fragment as $, renderList as L, mergeProps as Ve, toDisplayString as A, createTextVNode as Me, nextTick as ut } from "vue";
import { u as rt, c as st, t as nt, p as B, a as it, o as vt, e as ne, g as ct, b as dt, i as R, f as _, X as ht, s as pt, w as yt, G as ft, L as gt, d as mt, q as bt, r as wt, x as kt, y as xt } from "./index-BPqWE-b3.js";
import { t as Ct, u as $t } from "./useResponsive-BWapHhVH.js";
import { _ as _t } from "./Title-DMc-mPaa.js";
import { u as Tt, U as It } from "./usePrinter-BwRGBS5r.js";
import { _ as St } from "./Tooltip-mwG8vT4x.js";
import { D as Pt } from "./DataTable-DDf8M9Hq.js";
import { L as Ot } from "./Legend-Doua5Aae.js";
import Lt from "./vue-ui-skeleton-Bhvrmh-5.js";
import At from "./vue-ui-accordion-CacxwDXH.js";
import { u as De } from "./useNestedProp-BCYrFQiV.js";
import { _ as Ft } from "./PackageVersion-D9_yrNr4.js";
import { P as zt } from "./PenAndPaper-LDJqsGXg.js";
import { u as Nt } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as Bt } from "./Shape-BoT6GMVY.js";
import { _ as Vt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Mt = ["id"], Dt = ["xmlns", "viewBox"], Ut = ["id"], Gt = ["stop-color"], Rt = ["stop-color"], jt = ["id"], Et = ["x", "y", "height", "width"], Wt = ["height", "width"], qt = { key: 0 }, Ht = ["rx", "x", "y", "height", "width", "stroke", "stroke-width", "filter"], Xt = ["rx", "x", "y", "height", "width", "fill", "stroke", "stroke-width", "filter"], Yt = { key: 1 }, Jt = ["rx", "x", "y", "height", "width", "fill", "filter"], Kt = ["x", "y", "height", "width", "filter"], Qt = { key: 0 }, Zt = { key: 1 }, el = { key: 2 }, tl = { key: 3 }, ll = ["onMouseover", "x", "y", "height", "width"], al = {
  key: 5,
  class: "vue-data-ui-watermark"
}, ol = ["onClick"], ul = { key: 0 }, rl = { key: 1 }, sl = ["innerHTML"], nl = {
  __name: "vue-ui-waffle",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(Ue, { expose: Ge, emit: Re }) {
    const { vue_ui_waffle: je } = rt(), b = Ue, Ee = lt(), X = d(() => !!b.dataset && b.dataset.length), k = v(st()), We = v(null), ee = v(!1), te = v(""), V = v(null), ie = v(0), M = v(null), ve = v(null), ce = v(null), de = v(null), he = v(null), pe = v(0), ye = v(0), fe = v(0), e = d({
      get: () => be(),
      set: (t) => t
    }), { userOptionsVisible: le, setUserOptionsVisibility: ge, keepUserOptionState: me } = Nt({ config: e.value });
    function be() {
      const t = De({
        userConfig: b.config,
        defaultConfig: je
      });
      return t.theme ? {
        ...De({
          userConfig: it.vue_ui_waffle[t.theme] || b.config,
          defaultConfig: t
        }),
        customPalette: nt[t.theme] || B
      } : t;
    }
    ze(() => b.config, (t) => {
      e.value = be(), le.value = !e.value.userOptions.showOnChartHover, we(), pe.value += 1, ye.value += 1, fe.value += 1, C.value.showTable = e.value.table.show, C.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const Y = v(null);
    function we() {
      if (vt(b.dataset) ? ne({
        componentName: "VueUiWaffle",
        type: "dataset"
      }) : b.dataset.forEach((t, a) => {
        ct({
          datasetObject: t,
          requiredAttributes: ["name", "values"]
        }).forEach((l) => {
          ne({
            componentName: "VueUiWaffle",
            type: "datasetSerieAttribute",
            property: l,
            index: a
          });
        });
      }), e.value.responsive) {
        const t = Ct(() => {
          const { width: a, height: l } = $t({
            chart: M.value,
            title: e.value.style.chart.title.text ? ve.value : null,
            legend: e.value.style.chart.legend.show ? ce.value : null,
            source: de.value,
            noTitle: he.value
          });
          requestAnimationFrame(() => {
            F.value.width = a, F.value.height = l, T.value.width = a, T.value.height = l;
          });
        });
        Y.value = new ResizeObserver(t), Y.value.observe(M.value.parentNode);
      }
    }
    at(() => {
      we();
    }), ot(() => {
      Y.value && Y.value.disconnect();
    });
    const { isPrinting: ke, isImaging: xe, generatePdf: Ce, generateImage: $e } = Tt({
      elementId: `vue-ui-waffle_${k.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-waffle"
    }), qe = d(() => e.value.userOptions.show && !e.value.style.chart.title.text), _e = d(() => dt(e.value.customPalette)), C = v({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), F = v({
      height: 512,
      width: 512
    }), T = v({
      top: 0,
      left: 0,
      height: 512,
      width: 512
    }), I = d(() => (T.value.width - e.value.style.chart.layout.grid.size * e.value.style.chart.layout.grid.spaceBetween) / e.value.style.chart.layout.grid.size), S = d(() => (T.value.height - e.value.style.chart.layout.grid.size * e.value.style.chart.layout.grid.spaceBetween) / e.value.style.chart.layout.grid.size), j = d(() => T.value.width / e.value.style.chart.layout.grid.size), J = d(() => T.value.height / e.value.style.chart.layout.grid.size);
    function Te(t) {
      const a = e.value.style.chart.layout.grid.size * e.value.style.chart.layout.grid.size, l = t.reduce((w, re) => w + re, 0), o = t.map((w) => w / l * a), u = o.map(Math.floor), i = o.map((w) => w % 1);
      let f = a - u.reduce((w, re) => w + re, 0);
      for (; f > 0; ) {
        let w = i.indexOf(Math.max(...i));
        u[w] += 1, i[w] = 0, f -= 1;
      }
      return u;
    }
    function Ie() {
      return b.dataset.map((t, a) => ({
        ...t,
        color: mt(t.color) || _e.value[a] || B[a] || B[a % B.length],
        uid: `serie_${a}`,
        absoluteIndex: a
      }));
    }
    const ae = d(() => Ie()), h = v(ae.value);
    ze(() => b.dataset, (t) => {
      h.value = Ie();
    }, { deep: !0 });
    const He = d(() => {
      const t = h.value.filter((a, l) => !p.value.includes(a.uid)).map((a, l) => (a.values || []).reduce((o, u) => o + u, 0));
      return Te(t);
    }), Xe = d(() => {
      const t = h.value.map((a, l) => (a.values || []).reduce((o, u) => o + u));
      return Te(t);
    }), E = d(() => (b.dataset.forEach((t, a) => {
      [null, void 0].includes(t.values) && ne({
        componentName: "VueUiWaffle",
        type: "datasetSerieAttribute",
        property: "values (number[])",
        index: a
      });
    }), h.value.filter((t, a) => !p.value.includes(t.uid)).map((t, a) => ({
      absoluteIndex: t.absoluteIndex,
      uid: t.uid,
      name: t.name,
      color: t.color,
      value: (t.values || []).reduce((l, o) => l + o, 0),
      absoluteValues: t.values || [],
      proportion: He.value[a]
    })))), Ye = d(() => h.value.map((t, a) => ({
      absoluteIndex: t.absoluteIndex,
      uid: t.uid,
      name: t.name,
      color: t.color,
      value: (t.values || []).reduce((l, o) => l + o, 0),
      absoluteValues: t.values || [],
      proportion: Xe.value[a]
    })));
    function Je() {
      return Ye.value.map((t) => ({
        name: t.name,
        color: t.color,
        value: t.value,
        proportion: t.proportion
      }));
    }
    const Ke = d(() => {
      let t = 0;
      return E.value.map((a, l) => {
        const o = t, u = o + a.proportion, i = [];
        for (let f = Math.floor(o); f < Math.floor(u); f += 1)
          i.push(f);
        return t = u, {
          ...a,
          start: o,
          rects: i
        };
      });
    }), n = d(() => Ke.value.flatMap((t, a) => t.rects.map((l, o) => ({
      isFirst: o === 0,
      isLongEnough: l.length > 2,
      name: t.name,
      color: t.color,
      value: t.value,
      serieIndex: a,
      absoluteStartIndex: o < 3,
      serieId: t.uid,
      ...t
    }))).map((t, a) => ({
      ...t,
      isAbsoluteFirst: a % e.value.style.chart.layout.grid.size === 0
    }))), D = d(() => {
      const t = [];
      for (let a = 0; a < e.value.style.chart.layout.grid.size; a += 1)
        for (let l = 0; l < e.value.style.chart.layout.grid.size; l += 1)
          t.push({
            isStartOfLine: l === 0,
            position: e.value.style.chart.layout.grid.vertical ? a : l,
            x: (e.value.style.chart.layout.grid.vertical ? a : l) * (I.value + e.value.style.chart.layout.grid.spaceBetween),
            y: (e.value.style.chart.layout.grid.vertical ? l : a) * (S.value + e.value.style.chart.layout.grid.spaceBetween) + T.value.top
          });
      return t;
    }), p = v([]), z = v(!1), Se = v(null), Pe = v(null);
    function Oe(t) {
      if (!e.value.useAnimation) {
        p.value.includes(t) ? p.value = p.value.filter((u) => u !== t) : p.value.length < U.value.length - 1 && U.value.length > 1 && p.value.push(t);
        return;
      }
      const a = ae.value.find((u) => u.uid === t).values.reduce((u, i) => u + i, 0), l = h.value.find((u) => u.uid === t).values.reduce((u, i) => u + i, 0);
      let o = l;
      if (p.value.includes(t)) {
        let i = function() {
          o > u ? (cancelAnimationFrame(Se.value), h.value = h.value.map((f, w) => f.uid === t ? {
            ...f,
            values: [u]
          } : f), z.value = !1) : (z.value = !0, o += u * 0.025, h.value = h.value.map((f, w) => f.uid === t ? {
            ...f,
            values: [o]
          } : f), Se.value = requestAnimationFrame(i));
        };
        p.value = p.value.filter((f) => f !== t);
        const u = a;
        i();
      } else if (p.value.length < U.value.length - 1 && U.value.length > 1) {
        let u = function() {
          o < l / 100 ? (cancelAnimationFrame(Pe.value), p.value.push(t), h.value = h.value.map((i, f) => i.uid === t ? {
            ...i,
            values: [0]
          } : i), z.value = !1) : (z.value = !0, o /= 1.15, h.value = h.value.map((i) => i.uid === t ? {
            ...i,
            values: [o]
          } : i), Pe.value = requestAnimationFrame(u));
        };
        u();
      }
      et("selectLegend", E.value.map((u) => ({
        name: u.name,
        color: u.color,
        value: u.value,
        proportion: u.proportion / Math.pow(e.value.style.chart.layout.grid.size, 2)
      })));
    }
    const U = d(() => h.value.map((t, a) => ({
      name: t.name,
      color: t.color || _e[a] || B[a] || B[a % B.length],
      value: (t.values || []).reduce((l, o) => l + o, 0),
      uid: t.uid,
      shape: "square"
    })).map((t) => ({
      ...t,
      proportion: t.value / h.value.map((a) => (a.values || []).reduce((l, o) => l + o, 0)).reduce((a, l) => a + l, 0),
      opacity: p.value.includes(t.uid) ? 0.5 : 1,
      segregate: () => Oe(t.uid),
      isSegregated: p.value.includes(t.uid)
    }))), Qe = d(() => ({
      cy: "waffle-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), P = d(() => E.value.map((t) => t.value).reduce((t, a) => t + a, 0)), oe = v(null);
    function Ze(t) {
      if (p.value.length === b.dataset.length) return;
      const a = n.value[t];
      oe.value = {
        datapoint: a,
        seriesIndex: a.absoluteIndex,
        series: h.value,
        config: e.value
      }, ee.value = !0, V.value = n.value[t].serieIndex;
      const l = e.value.style.chart.tooltip.customFormat;
      if (kt(l) && xt(() => l({
        seriesIndex: n.value[t].absoluteIndex,
        datapoint: a,
        series: h.value,
        config: e.value
      })))
        te.value = l({
          seriesIndex: n.value[t].absoluteIndex,
          datapoint: a,
          series: h.value,
          config: e.value
        });
      else {
        let o = "";
        if (o += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${a.name}</div>`, o += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 60 60" height="14" width="14"><rect x="0" y="0" height="60" width="60" stroke="none" rx="1" fill="${a.color}" />${Ee.pattern ? `<rect x="0" y="0" height="60" width="60" stroke="none" rx="1" stroke="none" fill="url(#pattern_${k.value}_${a.absoluteIndex})"/>` : ""}</svg>`, e.value.style.chart.tooltip.showValue && (o += `<b>${R(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          a.value,
          _({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: a.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          {
            datapoint: a,
            seriesIndex: n.value[t].absoluteIndex,
            series: h.value
          }
        )}</b>`), e.value.style.chart.tooltip.showPercentage) {
          const u = _({
            v: a.value / P.value * 100,
            s: "%",
            r: e.value.style.chart.tooltip.roundingPercentage
          });
          e.value.style.chart.tooltip.showValue ? o += `<span>(${u})</span></div>` : o += `<b>${u}%</b></div>`;
        }
        te.value = o;
      }
    }
    const et = Re, O = d(() => {
      const t = E.value.map((l) => ({
        name: l.name,
        color: l.color
      })), a = E.value.map((l) => l.value);
      return { head: t, body: a };
    });
    function K(t) {
      return e.value.useBlurOnHover && ![null, void 0].includes(V.value) && V.value !== t ? `url(#blur_${k.value})` : "";
    }
    function Le() {
      ut(() => {
        const t = O.value.head.map((o, u) => [[
          o.name
        ], [O.value.body[u]], [isNaN(O.value.body[u] / P.value) ? "-" : O.value.body[u] / P.value * 100]]), a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), l = bt(a);
        wt({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-waffle" });
      });
    }
    const Q = d(() => {
      const t = [
        ' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>',
        R(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          P.value,
          _({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: P.value,
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.table.td.roundingValue
          })
        ),
        "100%"
      ], a = O.value.head.map((u, i) => [
        {
          color: u.color,
          name: u.name
        },
        R(
          e.value.style.chart.layout.labels.dataLabels.formatter,
          O.value.body[i],
          _({
            p: e.value.style.chart.layout.labels.dataLabels.prefix,
            v: O.value.body[i],
            s: e.value.style.chart.layout.labels.dataLabels.suffix,
            r: e.value.table.td.roundingValue
          })
        ),
        isNaN(O.value.body[i] / P.value) ? "-" : _({
          v: O.value.body[i] / P.value * 100,
          s: "%",
          r: e.value.table.td.roundingPercentage
        })
      ]), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        shape: "square",
        breakpoint: e.value.table.responsiveBreakpoint
      }, o = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ];
      return {
        head: t,
        body: a,
        config: l,
        colNames: o
      };
    }), G = v(!1);
    function tt(t) {
      G.value = t, ie.value += 1;
    }
    function Ae() {
      C.value.showTable = !C.value.showTable;
    }
    function Fe() {
      C.value.showTooltip = !C.value.showTooltip;
    }
    const Z = v(!1);
    function ue() {
      Z.value = !Z.value;
    }
    return Ge({
      getData: Je,
      generatePdf: Ce,
      generateCsv: Le,
      generateImage: $e,
      toggleTable: Ae,
      toggleTooltip: Fe,
      toggleAnnotator: ue
    }), (t, a) => (r(), s("div", {
      class: Ne(`vue-ui-waffle ${G.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      ref_key: "waffleChart",
      ref: M,
      id: `vue-ui-waffle_${k.value}`,
      style: W(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`),
      onMouseenter: a[3] || (a[3] = () => c(ge)(!0)),
      onMouseleave: a[4] || (a[4] = () => c(ge)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (r(), N(zt, {
        key: 0,
        parent: M.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: Z.value,
        onClose: ue
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : y("", !0),
      qe.value ? (r(), s("div", {
        key: 1,
        ref_key: "noTitle",
        ref: he,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : y("", !0),
      e.value.style.chart.title.text ? (r(), s("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: ve,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (r(), N(_t, {
          key: `title_${pe.value}`,
          config: {
            title: {
              cy: "waffle-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "waffle-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && X.value && (c(me) || c(le)) ? (r(), N(It, {
        ref_key: "details",
        ref: We,
        key: `user_options_${ie.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: c(ke),
        isImaging: c(xe),
        uid: k.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: G.value,
        isTooltip: C.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: M.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: Z.value,
        onToggleFullscreen: tt,
        onGeneratePdf: c(Ce),
        onGenerateCsv: Le,
        onGenerateImage: c($e),
        onToggleTable: Ae,
        onToggleTooltip: Fe,
        onToggleAnnotator: ue,
        style: W({
          visibility: c(me) ? c(le) ? "visible" : "hidden" : "visible"
        })
      }, Be({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: m(() => [
            g(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            g(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            g(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            g(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            g(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: l, isFullscreen: o }) => [
            g(t.$slots, "optionFullscreen", q(H({ toggleFullscreen: l, isFullscreen: o })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: m(({ toggleAnnotator: l, isAnnotator: o }) => [
            g(t.$slots, "optionAnnotator", q(H({ toggleAnnotator: l, isAnnotator: o })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : y("", !0),
      X.value ? (r(), s("svg", {
        key: 4,
        xmlns: c(ht),
        class: Ne({ "vue-data-ui-fullscreen--on": G.value, "vue-data-ui-fulscreen--off": !G.value }),
        viewBox: `0 0 ${F.value.width <= 0 ? 10 : F.value.width} ${F.value.height <= 0 ? 10 : F.value.height}`,
        style: W(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color}`)
      }, [
        se(Ft),
        x("defs", null, [
          (r(!0), s($, null, L(n.value, (l, o) => (r(), s("radialGradient", {
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%",
            id: `gradient_${k.value}_${o}`
          }, [
            x("stop", {
              offset: "0%",
              "stop-color": c(pt)(c(yt)(l.color, 0.05), 100 - e.value.style.chart.layout.rect.gradientIntensity)
            }, null, 8, Gt),
            x("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, Rt)
          ], 8, Ut))), 256))
        ]),
        x("defs", null, [
          x("filter", {
            id: `blur_${k.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, a[5] || (a[5] = [
            x("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2
            }, null, -1),
            x("feColorMatrix", {
              type: "saturate",
              values: "0"
            }, null, -1)
          ]), 8, jt)
        ]),
        e.value.useCustomCells && n.value.length ? (r(!0), s($, { key: 0 }, L(D.value, (l, o) => (r(), s("foreignObject", {
          x: l.x,
          y: l.y,
          height: S.value <= 0 ? 1e-4 : S.value,
          width: I.value <= 0 ? 1e-4 : I.value,
          class: "vue-ui-waffle-custom-cell-foreignObject"
        }, [
          g(t.$slots, "cell", Ve({ ref_for: !0 }, { cell: { ...l, color: n.value[o].color, ...n.value[o] }, isSelected: [null, void 0].includes(V.value) ? !0 : n.value[o].serieIndex === V.value }), void 0, !0)
        ], 8, Et))), 256)) : y("", !0),
        !n.value.length && !e.value.useCustomCells ? (r(), s("rect", {
          key: 1,
          x: 12,
          y: 12,
          height: T.value.height - 24,
          width: T.value.width - 24,
          rx: 3,
          fill: "none",
          stroke: "black"
        }, null, 8, Wt)) : n.value.length && !e.value.useCustomCells ? (r(), s($, { key: 2 }, [
          t.$slots.pattern ? (r(), s("g", qt, [
            (r(!0), s($, null, L(ae.value, (l) => (r(), s("defs", null, [
              g(t.$slots, "pattern", Ve({ ref_for: !0 }, { seriesIndex: l.absoluteIndex, patternId: `pattern_${k.value}_${l.absoluteIndex}` }), void 0, !0)
            ]))), 256))
          ])) : y("", !0),
          (r(!0), s($, null, L(D.value, (l, o) => (r(), s("rect", {
            rx: e.value.style.chart.layout.rect.rounded ? e.value.style.chart.layout.rect.rounding : 0,
            x: l.x + e.value.style.chart.layout.grid.spaceBetween / 2,
            y: l.y + e.value.style.chart.layout.grid.spaceBetween / 2,
            height: S.value <= 0 ? 1e-4 : S.value,
            width: I.value <= 0 ? 1e-4 : I.value,
            fill: "white",
            stroke: e.value.style.chart.layout.rect.stroke,
            "stroke-width": e.value.style.chart.layout.rect.strokeWidth,
            filter: K(n.value[o].serieIndex)
          }, null, 8, Ht))), 256)),
          (r(!0), s($, null, L(D.value, (l, o) => (r(), s("rect", {
            rx: e.value.style.chart.layout.rect.rounded ? e.value.style.chart.layout.rect.rounding : 0,
            x: l.x + e.value.style.chart.layout.grid.spaceBetween / 2,
            y: l.y + e.value.style.chart.layout.grid.spaceBetween / 2,
            height: S.value <= 0 ? 1e-4 : S.value,
            width: I.value <= 0 ? 1e-4 : I.value,
            fill: e.value.style.chart.layout.rect.useGradient && e.value.style.chart.layout.rect.gradientIntensity > 0 ? `url(#gradient_${k.value}_${o})` : n.value[o].color,
            stroke: e.value.style.chart.layout.rect.stroke,
            "stroke-width": e.value.style.chart.layout.rect.strokeWidth,
            filter: K(n.value[o].serieIndex)
          }, null, 8, Xt))), 256)),
          t.$slots.pattern ? (r(), s("g", Yt, [
            (r(!0), s($, null, L(D.value, (l, o) => (r(), s("rect", {
              rx: e.value.style.chart.layout.rect.rounded ? e.value.style.chart.layout.rect.rounding : 0,
              x: l.x + e.value.style.chart.layout.grid.spaceBetween / 2,
              y: l.y + e.value.style.chart.layout.grid.spaceBetween / 2,
              height: S.value <= 0 ? 1e-4 : S.value,
              width: I.value <= 0 ? 1e-4 : I.value,
              fill: `url(#pattern_${k.value}_${n.value[o].absoluteIndex})`,
              stroke: "none",
              filter: K(n.value[o].serieIndex)
            }, null, 8, Jt))), 256))
          ])) : y("", !0)
        ], 64)) : y("", !0),
        (r(!0), s($, null, L(D.value, (l, o) => (r(), s($, null, [
          n.value.length && !z.value && !e.value.style.chart.layout.grid.vertical && e.value.style.chart.layout.labels.captions.show && (n.value[o].isFirst && l.position < e.value.style.chart.layout.grid.size - 2 || n.value[o].isAbsoluteFirst && o % e.value.style.chart.layout.grid.size === 0 && n.value[o].absoluteStartIndex) ? (r(), s("foreignObject", {
            key: 0,
            x: l.x + e.value.style.chart.layout.labels.captions.offsetX + e.value.style.chart.layout.grid.spaceBetween / 2,
            y: l.y + e.value.style.chart.layout.labels.captions.offsetY + e.value.style.chart.layout.grid.spaceBetween / 2,
            height: J.value <= 0 ? 1e-4 : J.value,
            width: j.value * e.value.style.chart.layout.grid.size <= 0 ? 1e-4 : j.value * e.value.style.chart.layout.grid.size,
            filter: K(n.value[o].serieIndex)
          }, [
            x("div", {
              class: "vue-ui-waffle-caption",
              style: W(`height: 100%; width: 100%; font-size:${e.value.style.chart.layout.labels.captions.fontSize}px;display:flex;align-items:center;justify-content:flex-start;padding: 0 ${j.value / 12}px;color:${c(ft)(n.value[o].color)};gap:2px`)
            }, [
              e.value.style.chart.layout.labels.captions.showSerieName ? (r(), s("span", Qt, A(e.value.style.chart.layout.labels.captions.serieNameAbbreviation ? c(gt)({ source: n.value[o].name, length: e.value.style.chart.layout.labels.captions.serieNameMaxAbbreviationSize }) : n.value[o].name) + ": ", 1)) : y("", !0),
              e.value.style.chart.layout.labels.captions.showPercentage ? (r(), s("span", Zt, A(c(_)({ v: n.value[o].proportion, s: "%", r: e.value.style.chart.layout.labels.captions.roundingPercentage })), 1)) : y("", !0),
              e.value.style.chart.layout.labels.captions.showPercentage && e.value.style.chart.layout.labels.captions.showValue ? (r(), s("span", el, " (" + A(c(R)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                n.value[o].value,
                c(_)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: n.value[o].value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.captions.roundingValue
                }),
                { datapoint: n.value[o], position: l }
              )) + ") ", 1)) : y("", !0),
              !e.value.style.chart.layout.labels.captions.showPercentage && e.value.style.chart.layout.labels.captions.showValue ? (r(), s("span", tl, A(c(R)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                n.value[o].value,
                c(_)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: n.value[o].value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.layout.labels.captions.roundingValue
                }),
                { datapoint: n.value[o], position: l }
              )), 1)) : y("", !0)
            ], 4)
          ], 8, Kt)) : y("", !0)
        ], 64))), 256)),
        (r(!0), s($, null, L(D.value, (l, o) => (r(), s("rect", {
          onMouseover: (u) => Ze(o),
          onMouseleave: a[0] || (a[0] = (u) => {
            ee.value = !1, V.value = null;
          }),
          x: l.x + e.value.style.chart.layout.grid.spaceBetween / 2,
          y: l.y + e.value.style.chart.layout.grid.spaceBetween / 2,
          height: J.value <= 0 ? 1e-4 : J.value,
          width: j.value <= 0 ? 1e-4 : j.value,
          fill: "transparent",
          stroke: "none"
        }, null, 40, ll))), 256)),
        g(t.$slots, "svg", { svg: F.value }, void 0, !0)
      ], 14, Dt)) : y("", !0),
      t.$slots.watermark ? (r(), s("div", al, [
        g(t.$slots, "watermark", q(H({ isPrinting: c(ke) || c(xe) })), void 0, !0)
      ])) : y("", !0),
      X.value ? y("", !0) : (r(), N(Lt, {
        key: 6,
        config: {
          type: "waffle",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            waffle: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      x("div", {
        ref_key: "chartLegend",
        ref: ce
      }, [
        e.value.style.chart.legend.show ? (r(), N(Ot, {
          key: `legend_${fe.value}`,
          legendSet: U.value,
          config: Qe.value,
          onClickMarker: a[1] || (a[1] = ({ legend: l }) => Oe(l.uid))
        }, Be({
          item: m(({ legend: l }) => [
            x("div", {
              onClick: (o) => l.segregate(),
              style: W(`opacity:${p.value.includes(l.uid) ? 0.5 : 1}`)
            }, [
              Me(A(l.name) + ": " + A(c(R)(
                e.value.style.chart.layout.labels.dataLabels.formatter,
                l.value,
                c(_)({
                  p: e.value.style.chart.layout.labels.dataLabels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.dataLabels.suffix,
                  r: e.value.style.chart.legend.roundingValue,
                  isAnimating: z.value
                }),
                { datapoint: l }
              )) + " ", 1),
              p.value.includes(l.uid) ? (r(), s("span", rl, " ( - % ) ")) : (r(), s("span", ul, " (" + A(isNaN(l.value / P.value) ? "-" : c(_)({ v: l.value / P.value * 100, s: "%", r: e.value.style.chart.legend.roundingPercentage, isAnimating: z.value })) + ") ", 1))
            ], 12, ol)
          ]),
          _: 2
        }, [
          t.$slots.pattern ? {
            name: "legend-pattern",
            fn: m(({ legend: l, index: o }) => [
              se(Bt, {
                shape: l.shape,
                radius: 30,
                stroke: "none",
                plot: { x: 30, y: 30 },
                fill: `url(#pattern_${k.value}_${o})`
              }, null, 8, ["shape", "fill"])
            ]),
            key: "0"
          } : void 0
        ]), 1032, ["legendSet", "config"])) : g(t.$slots, "legend", {
          key: 1,
          legend: U.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (r(), s("div", {
        key: 7,
        ref_key: "source",
        ref: de,
        dir: "auto"
      }, [
        g(t.$slots, "source", {}, void 0, !0)
      ], 512)) : y("", !0),
      se(St, {
        show: C.value.showTooltip && ee.value && p.value.length < b.dataset.length,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: M.value,
        content: te.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function",
        fontSize: e.value.style.chart.tooltip.fontSize,
        isFullscreen: G.value
      }, {
        "tooltip-before": m(() => [
          g(t.$slots, "tooltip-before", q(H({ ...oe.value })), void 0, !0)
        ]),
        "tooltip-after": m(() => [
          g(t.$slots, "tooltip-after", q(H({ ...oe.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "fontSize", "isFullscreen"]),
      X.value ? (r(), N(At, {
        key: 8,
        hideDetails: "",
        config: {
          open: C.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (r(), N(Pt, {
            key: `table_${ye.value}`,
            colNames: Q.value.colNames,
            head: Q.value.head,
            body: Q.value.body,
            config: Q.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[2] || (a[2] = (l) => C.value.showTable = !1)
          }, {
            th: m(({ th: l }) => [
              x("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, sl)
            ]),
            td: m(({ td: l }) => [
              Me(A(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 46, Mt));
  }
}, _l = /* @__PURE__ */ Vt(nl, [["__scopeId", "data-v-5a674907"]]);
export {
  _l as default
};
